Snow_OTBar =
{
Break = false,
bAdjustUIPos = false,
bCraftAll = false,
bFade = false,
bNewBar = false,
nFadeAlpha = 255,
nStartTickCount = 0,
nStartTickCountSave = 0,
nEndTickCount = 0,
nEndTickCountSave = 0,
nProgressType = 0,
nIconW = 0,
nIconH = 0,
nAnimateMin = 0.7,
nAnimateMax = 1.5,
nAnimateW = 0,
nAnimateH = 0,
nAnimateChange = 0,
SkillName = "",
Results_S = "",
Results_F = "",
Divider = "",
}

Snow_OTBar.UserData =
{
Anchor = {s = "BOTTOMCENTER", r = "BOTTOMCENTER",  x = 0, y = -255},
bCloseSystemBar = true,
bShowError = false,
}

RegisterCustomData("Snow_OTBar.UserData")

function Snow_OTBar.OnFrameCreate()

	this:RegisterEvent("DO_SKILL_PREPARE_PROGRESS")
	this:RegisterEvent("DO_SKILL_CHANNEL_PROGRESS")
	this:RegisterEvent("OT_ACTION_PROGRESS_UPDATE")
	this:RegisterEvent("OT_ACTION_PROGRESS_BREAK")
	this:RegisterEvent("DO_PICK_PREPARE_PROGRESS")
	this:RegisterEvent("DO_CUSTOM_OTACTION_PROGRESS")
	this:RegisterEvent("DO_RECIPE_PREPARE_PROGRESS")
	this:RegisterEvent("DO_SKILL_HOARD_PROGRESS")
	this:RegisterEvent("DO_SKILL_HOARD_SUCCESS")

	this:RegisterEvent("UI_SCALED")
	this:RegisterEvent("ON_ENTER_CUSTOM_UI_MODE")
	this:RegisterEvent("ON_LEAVE_CUSTOM_UI_MODE")
	this:RegisterEvent("CUSTOM_DATA_LOADED")
	this:RegisterEvent("CALL_LUA_ERROR")

	this:EnableDrag(false)
	Snow_OTBar.UpdateAnchor(this)

end

function Snow_OTBar.OnFrameDragEnd()
	this:CorrectPos()
	Snow_OTBar.UserData.Anchor = GetFrameAnchor(this)
end

function Snow_OTBar.UpdateAnchor(frame)
	frame:SetPoint(Snow_OTBar.UserData.Anchor.s, 0, 0, Snow_OTBar.UserData.Anchor.r, Snow_OTBar.UserData.Anchor.x, Snow_OTBar.UserData.Anchor.y)
	frame:CorrectPos()
end

function Snow_OTBar.OnEvent(szEvent)
	if szEvent == "DO_SKILL_PREPARE_PROGRESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnSkillPrepareProgress()
	elseif szEvent == "DO_SKILL_CHANNEL_PROGRESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnSkillChannelProgress()
	elseif szEvent == "OT_ACTION_PROGRESS_UPDATE" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnActionProgressUpdate()
	elseif szEvent == "OT_ACTION_PROGRESS_BREAK" and not Snow_OTBar.bAdjustUIPos then
		if arg0 == GetClientPlayer().dwID then
			Snow_OTBar.OnActionProgressBreak()
		end
	elseif szEvent == "DO_PICK_PREPARE_PROGRESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnPickPrepareProgress()
	elseif szEvent == "DO_CUSTOM_OTACTION_PROGRESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnCustomOTActionProgress()
	elseif szEvent == "DO_RECIPE_PREPARE_PROGRESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnRecipeOTActionProgress()
	elseif szEvent == "DO_SKILL_HOARD_PROGRESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnSkillHoardProgress()
	elseif szEvent == "DO_SKILL_HOARD_SUCCESS" and not Snow_OTBar.bAdjustUIPos then
		Snow_OTBar.OnSkillHoardSuccess()
	elseif szEvent == "CUSTOM_DATA_LOADED" then
		if arg0 == "Role" then
			Snow_OTBar.UpdateAnchor(this)
			if Snow_OTBar.UserData.bCloseSystemBar then
				Wnd.CloseWindow("OTActionBar")
			end
		end
	elseif szEvent == "UI_SCALED" then
		Snow_OTBar.UpdateAnchor(this)
	elseif szEvent == "ON_ENTER_CUSTOM_UI_MODE" or szEvent == "ON_LEAVE_CUSTOM_UI_MODE" then
		Snow_OTBar.UpdatePos(this)
	elseif szEvent == "CALL_LUA_ERROR" then
		if Snow_OTBar.UserData.bShowError then
			OutputMessage("MSG_SYS", arg0)
		end
	end
end

function Snow_OTBar.OnFrameRender()

	if Snow_OTBar.bAdjustUIPos then
		return
	end

	if GetTickCount() < Snow_OTBar.nEndTickCount and not Snow_OTBar.bCraftAll and not Snow_OTBar.Break then
		Snow_OTBar.bFade = false
	end

	----------
	if Snow_OTBar.bFade then
		local frame = Station.Lookup("Topmost2/Snow_OTBar")
		frame:SetAlpha(Snow_OTBar.nFadeAlpha)
		Snow_OTBar.nFadeAlpha = Snow_OTBar.nFadeAlpha - 30
		if Snow_OTBar.nFadeAlpha <= 0 then
			frame:Hide()
			Snow_OTBar.nFadeAlpha = 0
			Snow_OTBar.bFade = false
		end
	end

	-----ɹ˸-----
	if GetTickCount() > Snow_OTBar.nEndTickCount and Snow_OTBar.nFadeAlpha > 0 and not Snow_OTBar.bCraftAll then
		Snow_OTBar.FlashProgressBar(true)
	end

	Snow_OTBar.UpdateProgressBar()

end


function Snow_OTBar.UpdatePos(frame)

	local handle = frame:Lookup("","")
	local page = frame:Lookup("Wnd_CustomMode")
	local bIn = UpdateCustomModeWindow(frame,"Сѩ",true)

	if bIn then
		Snow_OTBar.bAdjustUIPos = true
		frame:Show()
		page:Show()
		frame:EnableDrag(true)
		frame:SetAlpha(255)
		frame:SetDragArea(0,0,400,35)
		frame:SetMousePenetrable(false)
		handle:Lookup("Image_Icon"):FromIconID(13)
		handle:Lookup("Image_Results"):Hide()
		handle:Lookup("Image_Progress"):Show()
		handle:Lookup("Image_Progress"):SetPercentage(0.5)
		handle:Lookup("Text_SkillName"):Hide()
		handle:Lookup("Text_Time"):Hide()
		handle:Lookup("Animate_Lighting"):Hide()
		handle:Lookup("Image_Delay"):Hide()
		handle:Lookup("Handle_Divider_List"):Hide()
	else
		if not frame.bShow then
			Snow_OTBar.bAdjustUIPos = false
			page:Hide()
			handle:Lookup("Image_Delay"):Show()
			frame:EnableDrag(false)
			frame:SetMousePenetrable(true)
			frame:Hide()
		end
	end
end

function Snow_OTBar.FormatItemSetting()

	local frame = Station.Lookup("Topmost2/Snow_OTBar")
	local handle = frame:Lookup("","")
	Snow_OTBarSetting.CurrentSetting = clone(Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin])
	for k,v in pairs(Snow_OTBarSetting.CurrentSetting) do
		if k == "Background" or k == "Filling" or k == "Icon" or k == "Animate" or k == "TextName" or k == "TextTime" then
			local item
			if k == "Animate" then
				item = handle:Lookup("Animate_Icon")
			elseif k == "TextName" then
				item = handle:Lookup("Text_SkillName")
			elseif k == "TextTime" then
				item = handle:Lookup("Text_Time")
			elseif k == "Filling" then
				item = handle:Lookup("Image_Progress")
				handle:Lookup("Image_Delay"):SetAlpha(v.nAlpha)
				handle:Lookup("Image_Results"):SetAlpha(v.nAlpha)
			else
				item = handle:Lookup("Image_"..k)
			end

			if v.bShow then
				item:Show()
				item:SetAlpha(v.nAlpha)
			else
				item:Hide()
			end
		end
	end
end

function Snow_OTBar.ChangeSkin()

	local frame = Station.Lookup("Topmost2/Snow_OTBar")
	local handle = frame:Lookup("","")
	local szSkinName = Snow_OTBarSetting.UserData.szCurrentSkin

	local szIni = "interface\\Snow_OTBar\\Skins\\"..szSkinName.."\\"

	handle:Lookup("Image_Background"):FromTextureFile(szIni.."Background.tga")
	handle:Lookup("Image_Progress"):FromTextureFile(szIni.."Progress.tga")
	handle:Lookup("Image_Delay"):FromTextureFile(szIni.."Delay.tga")
	Snow_OTBar.Results_S = szIni.."Success.tga"
	Snow_OTBar.Results_F = szIni.."Interrupt.tga"
	Snow_OTBar.Divider = szIni.."Divider.tga"

	Snow_OTBarSetting.CurrentSetting = Snow_OTBarSetting.SkinScheme[szSkinName]

	for k,v in pairs(Snow_OTBarSetting.CurrentSetting) do

		if k == "Background" or k == "Filling" or k == "Icon" or k == "Animate" or k == "TextName" or k == "TextTime" then
			local item
			if k == "Animate" then
				item = handle:Lookup("Animate_Icon")
				item:SetAnimate(szIni..k..".UITex",0)
			elseif k == "TextName" then
				item = handle:Lookup("Text_SkillName")
				item:SetFontScheme(v.nFont)
				item:SetFontScale(v.nScale)
				item:SetFontColor(v.nR,v.nG,v.nB)
			elseif k == "TextTime" then
				item = handle:Lookup("Text_Time")
				item:SetFontScheme(v.nFont)
				item:SetFontScale(v.nScale)
				item:SetFontColor(v.nR,v.nG,v.nB)
			elseif k == "Filling" then
				item = handle:Lookup("Image_Progress")
				if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
					item:SetImageType(1)
				elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 1 then
					item:SetImageType(13)
				elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
					item:SetImageType(4)
				end
			else
				item = handle:Lookup("Image_"..k)
			end

			if not item then
				return
			end

			if v.bShow then
				item:Show()
				item:SetRelPos(v.nX,v.nY)
				item:SetSize(v.nW,v.nH)
				item:SetAlpha(v.nAlpha)
			else
				item:Hide()
			end
		end
	end

	if Snow_OTBarSetting.CurrentSetting.Lighting.bShow then

		local nPosX,nPosY = handle:Lookup("Image_Progress"):GetRelPos()
		local nWidth,nHeight = handle:Lookup("Image_Progress"):GetSize()
		handle:Lookup("Animate_Lighting"):Show()
		handle:Lookup("Animate_Lighting"):SetAlpha(Snow_OTBarSetting.CurrentSetting.Lighting.nAlpha)
		handle:Lookup("Animate_Lighting"):SetRelPos(nWidth + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nPosY + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
		handle:Lookup("Animate_Lighting"):SetAnimate(szIni.."Lighting.UITex",0)
	else

		handle:Lookup("Animate_Lighting"):Hide()
	end

	local nW,nH = handle:Lookup("Image_Progress"):GetSize()
	local nX,nY = handle:Lookup("Image_Progress"):GetRelPos()
	local nAlpha = handle:Lookup("Image_Progress"):GetAlpha()

	handle:Lookup("Image_Delay"):SetSize(nW,nH)
	handle:Lookup("Image_Delay"):SetRelPos(nX,nY)
	handle:Lookup("Image_Delay"):SetAlpha(nAlpha)
	handle:Lookup("Image_Results"):SetSize(nW,nH)
	handle:Lookup("Image_Results"):SetRelPos(nX,nY)
	handle:Lookup("Image_Results"):SetAlpha(nAlpha)
	handle:FormatAllItemPos()

end

function Snow_OTBar.OnActionProgressBreak()

	Snow_OTBar.FlashProgressBar(false)
	Snow_OTBar.nCraftNum = 0
	Snow_OTBar.bCraftAll = false
	Snow_OTBar.bSaveCurrentTime = false

end

function Snow_OTBar.OnSkillHoardSuccess()

	Snow_OTBar.FlashProgressBar(true)
	Snow_OTBar.bSaveCurrentTime = false
	Snow_OTBar.Break = true

end

function Snow_OTBar.OnActionProgressUpdate()

    local nFrame = arg0
	Snow_OTBar.nEndTickCount = Snow_OTBar.nEndTickCount + nFrame * 1000 / GLOBAL.GAME_FPS

end

function Snow_OTBar.UpdateProgressBar()

	if Snow_OTBar.Break then
		return
	end

	if CraftManagePanel.nMakeCount == 0 then
		Snow_OTBar.bCraftAll = false
	end

	if GetTickCount() > Snow_OTBar.nEndTickCount then
		return
	end

	local frame = Station.Lookup("Topmost2/Snow_OTBar")
	local handle = Station.Lookup("Topmost2/Snow_OTBar"):Lookup("","")
	local currenttime = 0
	local totaltime = 0

	if Snow_OTBar.nProgressType == 2 then
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
			handle:Lookup("Image_Delay"):SetImageType(1)
		elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 1 then
			handle:Lookup("Image_Delay"):SetImageType(13)
		elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
			handle:Lookup("Image_Delay"):SetImageType(4)
		end
		currenttime = tonumber(("%.2f"):format((Snow_OTBar.nEndTickCount - GetTickCount())/1000))
		totaltime = tonumber(("%.2f"):format((Snow_OTBar.nEndTickCountSave - Snow_OTBar.nStartTickCount)/1000))
	else
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
			handle:Lookup("Image_Delay"):SetImageType(2)
		elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 1 then
			handle:Lookup("Image_Delay"):SetImageType(5)
		elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
			handle:Lookup("Image_Delay"):SetImageType(3)
		end
		currenttime = tonumber(("%.2f"):format((GetTickCount() - Snow_OTBar.nStartTickCount)/1000))
		totaltime = tonumber(("%.2f"):format((Snow_OTBar.nEndTickCount - Snow_OTBar.nStartTickCount)/1000))
	end

	local nPercentage = currenttime / totaltime
	if nPercentage > 1 then
		nPercentage = 1
	elseif nPercentage < 0 then
		nPercentage = 0
	end

	if currenttime > totaltime then
		currenttime = totaltime
	elseif currenttime < 0 then
		currenttime = 0
	end

	handle:Lookup("Image_Progress"):SetPercentage(nPercentage)

	if currenttime > 10 and totaltime > 10 then
		handle:Lookup("Text_Time"):SetText(tostring(("%.0f"):format(currenttime)).." / "..tostring(("%.0f"):format(totaltime)))
	elseif totaltime > 10 then
		handle:Lookup("Text_Time"):SetText(tostring(("%.2f"):format(currenttime)).."/ "..tostring(("%.0f"):format(totaltime)))
	elseif currenttime > 10 then
		handle:Lookup("Text_Time"):SetText(tostring(("%.0f"):format(currenttime)).." /"..tostring(("%.2f"):format(totaltime)))
	else
		handle:Lookup("Text_Time"):SetText(tostring(("%.2f"):format(currenttime)).."/"..tostring(("%.2f"):format(totaltime)))
	end

	if Snow_OTBar.bNewBar then
		if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 then
			Snow_OTBar.nIconW,Snow_OTBar.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nW * 2,Snow_OTBarSetting.CurrentSetting.Icon.nH * 2
		elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
			Snow_OTBar.nIconW,Snow_OTBar.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nW * 0.5,Snow_OTBarSetting.CurrentSetting.Icon.nH * 0.5
		end
	end

	if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 or Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
		if Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 1 then
			Snow_OTBar.nIconW = Snow_OTBar.nIconW - 1
			Snow_OTBar.nIconH = Snow_OTBar.nIconH - 1
			if Snow_OTBar.nIconW < Snow_OTBarSetting.CurrentSetting.Icon.nW then
				Snow_OTBar.nIconW = Snow_OTBarSetting.CurrentSetting.Icon.nW
			end

			if Snow_OTBar.nIconH < Snow_OTBarSetting.CurrentSetting.Icon.nH then
				Snow_OTBar.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nH
			end
		elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 2 then
			Snow_OTBar.nIconW = Snow_OTBar.nIconW + 0.3
			Snow_OTBar.nIconH = Snow_OTBar.nIconH + 0.3

			if Snow_OTBar.nIconW > Snow_OTBarSetting.CurrentSetting.Icon.nW then
				Snow_OTBar.nIconW = Snow_OTBarSetting.CurrentSetting.Icon.nW
			end

			if Snow_OTBar.nIconH > Snow_OTBarSetting.CurrentSetting.Icon.nH then
				Snow_OTBar.nIconH = Snow_OTBarSetting.CurrentSetting.Icon.nH
			end
		end

		local nPosX = (Snow_OTBarSetting.CurrentSetting.Icon.nW / 2 - Snow_OTBar.nIconW / 2)
		local nPosY = (Snow_OTBarSetting.CurrentSetting.Icon.nH / 2 - Snow_OTBar.nIconH / 2)

		handle:Lookup("Image_Icon"):SetSize(Snow_OTBar.nIconW,Snow_OTBar.nIconH)
		handle:Lookup("Image_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Icon.nX + nPosX,Snow_OTBarSetting.CurrentSetting.Icon.nY + nPosY)

	elseif Snow_OTBarSetting.CurrentSetting.Icon.nMoveType == 3 then
		local nPosX,nPosY = handle:Lookup("Image_Progress"):GetRelPos()
		local nWidth,nHeight = handle:Lookup("Image_Progress"):GetSize()
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
			local nCurrentPos = nPercentage * nWidth
			handle:Lookup("Image_Icon"):SetRelPos(nCurrentPos,Snow_OTBarSetting.CurrentSetting.Icon.nY)
		elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
			local nCurrentPos = nPosY + nHeight - (nPercentage * nHeight)
			handle:Lookup("Image_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Icon.nX,nCurrentPos)
		end
	end

	if Snow_OTBarSetting.CurrentSetting.Lighting.bShow then
		local nPosX,nPosY = handle:Lookup("Image_Progress"):GetRelPos()
		local nWidth,nHeight = handle:Lookup("Image_Progress"):GetSize()
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 or Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
			handle:Lookup("Animate_Lighting"):Show()
			if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
				local nCurrentPos = (nPercentage * nWidth) + Snow_OTBarSetting.CurrentSetting.Lighting.nX + 20
				handle:Lookup("Animate_Lighting"):SetRelPos(nCurrentPos + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nPosY + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
				handle:Lookup("Animate_Lighting"):SetSize(Snow_OTBarSetting.CurrentSetting.Lighting.nW,nHeight + Snow_OTBarSetting.CurrentSetting.Lighting.nH)
			else
				local nCurrentPos = nPosY + nHeight - (nPercentage * nHeight) + Snow_OTBarSetting.CurrentSetting.Lighting.nY
				handle:Lookup("Animate_Lighting"):SetRelPos(nPosX + Snow_OTBarSetting.CurrentSetting.Lighting.nX,nCurrentPos + Snow_OTBarSetting.CurrentSetting.Lighting.nY)
				handle:Lookup("Animate_Lighting"):SetSize(nWidth + Snow_OTBarSetting.CurrentSetting.Lighting.nW,Snow_OTBarSetting.CurrentSetting.Lighting.nH)
			end
		else
			handle:Lookup("Animate_Lighting"):Hide()
		end

	else
		handle:Lookup("Animate_Lighting"):Hide()
	end

	if Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 1 then
		if Snow_OTBar.nAnimateChange == 1 then
			if Snow_OTBar.bNewBar then
				Snow_OTBar.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMax
				Snow_OTBar.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nH * Snow_OTBar.nAnimateMax
			end
			Snow_OTBar.nAnimateW = Snow_OTBar.nAnimateW - 1
			Snow_OTBar.nAnimateH = Snow_OTBar.nAnimateH - 1
		elseif Snow_OTBar.nAnimateChange == 2 then
			if Snow_OTBar.bNewBar then
				Snow_OTBar.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMin
				Snow_OTBar.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nH * Snow_OTBar.nAnimateMin
				Snow_OTBar.bNewBar = false
			end
			Snow_OTBar.nAnimateW = Snow_OTBar.nAnimateW + 1
			Snow_OTBar.nAnimateH = Snow_OTBar.nAnimateH + 1
		end


		if Snow_OTBar.nAnimateW < Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMin and Snow_OTBar.nAnimateChange == 1 then
			Snow_OTBar.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMin
			Snow_OTBar.nAnimateChange = 2
		elseif Snow_OTBar.nAnimateW > Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMax and Snow_OTBar.nAnimateChange == 2 then
			Snow_OTBar.nAnimateW = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMax
			Snow_OTBar.nAnimateChange = 1
		end

		if Snow_OTBar.nAnimateH < Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMin and Snow_OTBar.nAnimateChange == 1 then
			Snow_OTBar.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMin
			Snow_OTBar.nAnimateChange = 2
		elseif Snow_OTBar.nAnimateH > Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMax and Snow_OTBar.nAnimateChange == 2 then
			Snow_OTBar.nAnimateH = Snow_OTBarSetting.CurrentSetting.Animate.nW * Snow_OTBar.nAnimateMax
			Snow_OTBar.nAnimateChange = 1
		end

		local nPosX = Snow_OTBarSetting.CurrentSetting.Animate.nW / 2 - Snow_OTBar.nAnimateW / 2
		local nPosY = Snow_OTBarSetting.CurrentSetting.Animate.nH / 2 - Snow_OTBar.nAnimateH / 2

		handle:Lookup("Animate_Icon"):SetSize(Snow_OTBar.nAnimateW,Snow_OTBar.nAnimateH)
		handle:Lookup("Animate_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Animate.nX + nPosX,Snow_OTBarSetting.CurrentSetting.Animate.nY + nPosY)

	elseif Snow_OTBarSetting.CurrentSetting.Animate.nMoveType == 2 then
		local nPosX,nPosY = handle:Lookup("Image_Progress"):GetRelPos()
		local nWidth,nHeight = handle:Lookup("Image_Progress"):GetSize()
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
			local nCurrentPos = nPercentage * nWidth
			handle:Lookup("Animate_Icon"):SetRelPos(nCurrentPos,Snow_OTBarSetting.CurrentSetting.Animate.nY)
		elseif Snow_OTBarSetting.CurrentSetting.Frame.nType == 2 then
			local nCurrentPos = nPosY + nHeight - (nPercentage * nHeight)
			handle:Lookup("Animate_Icon"):SetRelPos(Snow_OTBarSetting.CurrentSetting.Animate.nX,nCurrentPos)
		end
	end

	Snow_OTBar.bNewBar = false
	handle:FormatAllItemPos()

end

--------------׼--------------
function Snow_OTBar.PrepareProgressBar(dwIconID,szName,nDivider)

	local frame = Station.Lookup("Topmost2/Snow_OTBar")
	local handle = frame:Lookup("","")

	frame:Show()
	frame:SetAlpha(255)

	Snow_OTBar.FormatItemSetting()

	if dwIconID == nil then
		handle:Lookup("Image_Icon"):FromIconID(13) --ɫ̫ͼ
	else
		handle:Lookup("Image_Icon"):FromIconID(dwIconID)
	end

	local ping = GetPingValue() / 2
	local value = ping / (Snow_OTBar.nEndTickCount - Snow_OTBar.nStartTickCount)

	if Snow_OTBar.nProgressType == 1 then
		handle:Lookup("Image_Delay"):SetPercentage(value)
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 1 then
			handle:Lookup("Image_Delay"):SetPercentage(1 - value)
		end
	else
		handle:Lookup("Image_Delay"):SetPercentage(value)
	end

	if Snow_OTBarSetting.CurrentSetting.Divider.bShow and Snow_OTBar.nProgressType == 2 and Snow_OTBarSetting.CurrentSetting.Frame.nType ~= 1 then
		if nDivider then
			if nDivider > 1 then
				local hI = handle:Lookup("Handle_Divider_List")
				hI:Show()
				hI:Clear()
				for i = 1,nDivider - 1 do
					local divider = hI:AppendItemFromIni("Interface\\Snow_OTBar\\Snow_OTBar.ini", "Handle_Divider","Handle_Divider_"..i)
					divider:SetRelPos(Snow_OTBarSetting.CurrentSetting.Divider.nX + Snow_OTBarSetting.CurrentSetting.Filling.nX + Snow_OTBarSetting.CurrentSetting.Filling.nW / nDivider * i,Snow_OTBarSetting.CurrentSetting.Divider.nY + Snow_OTBarSetting.CurrentSetting.Filling.nY)
					divider:Lookup("Image_Divider"):FromTextureFile(Snow_OTBar.Divider)
					divider:Lookup("Image_Divider"):SetSize(Snow_OTBarSetting.CurrentSetting.Divider.nW,Snow_OTBarSetting.CurrentSetting.Divider.nH)
					divider:SetAlpha(Snow_OTBarSetting.CurrentSetting.Divider.nAlpha)
				end
				hI:FormatAllItemPos()
			end
		end
	else
		handle:Lookup("Handle_Divider_List"):Hide()
	end

	handle:Lookup("Image_Results"):Hide()

	handle:Lookup("Text_SkillName"):SetText(szName)

	if Snow_OTBar.bCraftAll then
		handle:Lookup("Text_SkillName"):SetText(szName.."    "..(Snow_OTBar.nCraftNum - CraftManagePanel.nMakeCount + 1).."/"..Snow_OTBar.nCraftNum)
	end

	Snow_OTBar.nFadeAlpha = 255
	Snow_OTBar.bNewBar = true
	Snow_OTBar.nAnimateChange = 1

end

function Snow_OTBar.FlashProgressBar(bSuccess)

	local handle = Station.Lookup("Topmost2/Snow_OTBar"):Lookup("","")
	local image = handle:Lookup("Image_Progress")
	image:Hide()

	if bSuccess then
		image = handle:Lookup("Image_Results")
		image:Show()
		image:FromTextureFile(Snow_OTBar.Results_S)
	else
		image = handle:Lookup("Image_Results")
		image:Show()
		image:FromTextureFile(Snow_OTBar.Results_F)
		if Snow_OTBarSetting.CurrentSetting.Frame.nType == 0 then
			handle:Lookup("Text_SkillName"):SetText(Snow_OTBar.SkillName.."    Ѵ")
		else
			handle:Lookup("Text_SkillName"):SetText("Ѵ")
		end
		Snow_OTBar.Break = true
	end

	handle:Lookup("Animate_Lighting"):Hide()

	Snow_OTBar.bFade = true
	Snow_OTBar.nAnimateChange = 0
end

--༼
--
function Snow_OTBar.OnSkillPrepareProgress()
	local nTotalFrame = arg0

	if (nTotalFrame <= 0) then
	    return
	end

	Snow_OTBar.nStartTickCount = GetTickCount()
	Snow_OTBar.nEndTickCount = GetTickCount() + nTotalFrame * 1000 / GLOBAL.GAME_FPS

	Snow_OTBar.nProgressType = 1
	Snow_OTBar.Break = false

	local szName = Table_GetSkillName(arg1,arg2)
	local dwIconID = Table_GetSkillIconID(arg1,arg2)

	if arg1 == 4097 then
		dwIconID = Table_GetSkillIconID(605,1) --
	elseif arg1 == 3691 then
		dwIconID = Table_GetSkillIconID(81,1)
	end

	if dwIconID == 13 then
		local nCount = g_tTable.Item:GetRowCount()
		for i = 1, nCount do
			local tLine = g_tTable.Item:GetRow(i)
			if tLine.szName == szName then
				dwIconID = tLine.dwIconID
				break
			end
		end
	end

	Snow_OTBar.SkillName = szName
	Snow_OTBar.PrepareProgressBar(dwIconID,szName)
end

--
function Snow_OTBar.OnSkillChannelProgress()

	local nTotalFrame = arg0

	if (nTotalFrame <= 0) then
	    return
	end

	Snow_OTBar.nStartTickCount = GetTickCount()
	Snow_OTBar.nEndTickCount = GetTickCount() + nTotalFrame * 1000 / GLOBAL.GAME_FPS
	Snow_OTBar.nEndTickCountSave = Snow_OTBar.nEndTickCount

	Snow_OTBar.nProgressType = 2
	Snow_OTBar.Break = false

	local szName = Table_GetSkillName(arg1,arg2)
	local dwIconID = Table_GetSkillIconID(arg1,arg2)

	if arg1 == 3034 then
		dwIconID = 308
		szName = "ѩ"
	elseif arg1 == 3035 then
		dwIconID = 796
		szName = "ѪӰ輧"
	elseif arg1 == 4113 then
		dwIconID = 2891
		szName = "Ы"
	elseif arg1 == 3398 then
		dwIconID = 3193
	end

	Snow_OTBar.SkillName = szName

	local nCount

	if
	arg1 == 565 or --ѩƮҡ
	arg1 == 2707 or --Ҽ
	arg1 == 3100 or --
	arg1 == 4113 then --Ы
		nCount = 3
	elseif
	arg1 == 368 or --϶
	arg1 == 567 or --ת
	arg1 == 570 or --»к
	arg1 == 2636 or --ѩʱ
	arg1 == 2724 or --
	arg1 == 3093 or --滨
	arg1 == 3398 or --
	arg1 == 5268 or --
	arg1 == 6444 or --滨(Ⱥ)
	arg1 == 8604 or --Ѫѩʱ
	arg1 == 8606 then --Ѫ϶
		nCount = 5
	elseif arg1 == 2233 or arg1 == 6675 then -- & ()
		nCount = 5
		for k,v in pairs(GetClientPlayer().GetAllSkillList()) do
			if Table_GetSkillName(k,v) == "ɾ" then
				nCount = 7
				break
			end
		end
	elseif
	arg1 == 3034 or --ѩ
	arg1 == 3035 then --ѪӰ輧
		nCount = 6
	elseif
	arg1 == 1645 or --ɽ
	arg1 == 3985 then --ʥ
		nCount = 8
	elseif arg1 == 5270 then --Ц
		nCount = 9
	elseif
	arg1 == 300 or --
	arg1 == 8615 then --Ѫ
		nCount = 10
	elseif arg1 == 2235 then --ǧ
		nCount = 16
	end

	Snow_OTBar.PrepareProgressBar(dwIconID,szName,nCount)

end

--
function Snow_OTBar.OnSkillHoardProgress()

	local nTotalFrame = arg0

	if (nTotalFrame <= 0) then
	    return
	end

	Snow_OTBar.nStartTickCount = GetTickCount()
	Snow_OTBar.nEndTickCount = GetTickCount() + nTotalFrame * 1000 / GLOBAL.GAME_FPS

	Snow_OTBar.nProgressType = 1
	Snow_OTBar.Break = false

	local szName = Table_GetSkillName(arg1,arg2)
	local dwIconID = Table_GetSkillIconID(arg1,arg2)

	Snow_OTBar.SkillName = szName
	Snow_OTBar.PrepareProgressBar(dwIconID,szName)

end

function Snow_OTBar.OnPickPrepareProgress()

	local nTotalFrame = arg0

	if (nTotalFrame <= 0) then
	    return
	end

	local doodad = GetDoodad(arg1);
	local szName = doodad.szName
	local dwIconID = nil
	local doodadTemplate = GetDoodadTemplate(doodad.dwTemplateID);

	if doodadTemplate then
		local szBarText = ""
		local tDoodad = g_tTable.DoodadTemplate:Search(dwTemplateID)
		if tDoodad then
			szBarText = tDoodad.szBarText
		end
		if szBarText ~= "" then
			szName = szBarText;
		end

		if doodadTemplate.dwCraftID ~= 0 then
			local tCraft = g_tTable.UICraft:Search(dwCraftID)
			if tCraft then
				szName = tCraft.szName
			end
			local nCount = g_tTable.Craft:GetRowCount()
			for i = 1, nCount do
				local tLine = g_tTable.Craft:GetRow(i)
				if doodadTemplate.dwCraftID == tLine.dwProfessionID then
					dwIconID = tLine.dwIconID
					break
				end
			end
		end
	end

	Snow_OTBar.nStartTickCount = GetTickCount()
	Snow_OTBar.nEndTickCount = GetTickCount() + nTotalFrame * 1000 / GLOBAL.GAME_FPS

	Snow_OTBar.nProgressType = 1
	Snow_OTBar.Break = false
	Snow_OTBar.SkillName = szName

	Snow_OTBar.PrepareProgressBar(dwIconID,szName)

end

function Snow_OTBar.OnRecipeOTActionProgress()

	local nTotalFrame = arg0

	if (nTotalFrame <= 0) then
	    return
	end

	Snow_OTBar.nStartTickCount = GetTickCount()
	Snow_OTBar.nEndTickCount = GetTickCount() + nTotalFrame * 1000 / GLOBAL.GAME_FPS

	Snow_OTBar.nProgressType = 1
	Snow_OTBar.Break = false

	local szName = ""
	local dwIconID = -1

	if arg1 == 12 then
		local dwBookID, dwSegmentID = GlobelRecipeID2BookID(arg2)
		local tBookSegment = g_tTable.BookSegment:Search(dwBookID, dwSegmentID)
		if tBookSegment then
			szName = tBookSegment.szSegmentName
		end
		dwIconID = Table_GetItemIconID(GetItemInfo(5,tBookSegment.dwBookItemIndex).nUiId)
	else
		local recipe = GetRecipe(arg1,arg2)
		local nType = recipe.dwCreateItemType1
		local nID	= recipe.dwCreateItemIndex1
		szName = Table_GetItemName(GetItemInfo(nType,nID).nUiId)
		dwIconID = Table_GetItemIconID(GetItemInfo(nType,nID).nUiId)
	end

	Snow_OTBar.SkillName = szName
	Snow_OTBar.PrepareProgressBar(dwIconID,szName)

end

function Snow_OTBar.OnCustomOTActionProgress()

	local nTotalFrame = arg0

	if (nTotalFrame <= 0) then
	    return
	end

	Snow_OTBar.nStartTickCount = GetTickCount()
	Snow_OTBar.nEndTickCount = GetTickCount() + nTotalFrame * 1000 / GLOBAL.GAME_FPS

	if arg2 == 0 then
		Snow_OTBar.nProgressType = 1
		Snow_OTBar.Break = false
	else
		Snow_OTBar.nProgressType = 2
		Snow_OTBar.Break = false
	end
	Snow_OTBar.SkillName = arg1
	Snow_OTBar.PrepareProgressBar(nil,arg1)

end

Wnd.OpenWindow("Interface\\Snow_OTBar\\Snow_OTBar.ini","Snow_OTBar"):Hide()
