----------------------------------------------
-- ColorPanel
----------------------------------------------
Snow_OTBarColorPanel = {}

local _Snow_OTBarColorPanel = {
	f = nil
}

function Snow_OTBarColorPanel.OnFrameBreathe()

	if Station.GetActiveFrame() and Station.GetActiveFrame():GetName() ~= "Snow_OTBarColorPanel" then
		Station.Lookup("Topmost/Snow_OTBarColorPanel"):Hide()
		_Snow_OTBarColorPanel.f = nil
		local framepreview = Station.Lookup("Normal/Snow_OTBarPreview")
		if not framepreview then
			return
		end
		local preview = framepreview:Lookup("",""):Lookup("Handle_Preview")
		preview:Lookup("Text_Preview_TextName"):SetFontColor(Snow_OTBarSetting.CurrentSetting.TextName.nR,Snow_OTBarSetting.CurrentSetting.TextName.nG,Snow_OTBarSetting.CurrentSetting.TextName.nB)
		preview:Lookup("Text_Preview_TextTime"):SetFontColor(Snow_OTBarSetting.CurrentSetting.TextTime.nR,Snow_OTBarSetting.CurrentSetting.TextTime.nG,Snow_OTBarSetting.CurrentSetting.TextTime.nB)
	end

end

function Snow_OTBarColorPanel.OnItemLButtonClick()

	--_Snow_OTBarColorPanel.f(this:GetColorRGB())
	local framepreview = Station.Lookup("Normal/Snow_OTBarPreview")
	local handle = Station.Lookup("Topmost/Snow_OTBarColorPanel"):Lookup("","Handle_Color")
	handle:Lookup("Text_RGB"):SetText("˫ȷ")

	if Snow_OTBarFont.szName == "" then
		local text = framepreview:Lookup("",""):Lookup("Handle_Preview"):Lookup("Text_Preview_TextName")
		text:SetFontColor(this:GetColorRGB())
	elseif Snow_OTBarFont.szName == "ʱ" then
		local text = framepreview:Lookup("",""):Lookup("Handle_Preview"):Lookup("Text_Preview_TextTime")
		text:SetFontColor(this:GetColorRGB())
	end

end

function Snow_OTBarColorPanel.OnItemLButtonDBClick()

	_Snow_OTBarColorPanel.f(this:GetColorRGB())
	local handle = Station.Lookup("Topmost/Snow_OTBarColorPanel"):Lookup("","Handle_Color")
	handle:Lookup("Image_COver"):Hide()
	handle:Lookup("Shadow_CCOver"):Hide()
	handle:Lookup("Text_RGB"):SetText("")
	Station.Lookup("Topmost/Snow_OTBarColorPanel"):Hide()
	_Snow_OTBarColorPanel.f = nil
end

function Snow_OTBarColorPanel.OnItemMouseEnter()
	local handle = Station.Lookup("Topmost/Snow_OTBarColorPanel"):Lookup("","Handle_Color")
	handle:Lookup("Image_COver"):Show()
	handle:Lookup("Image_COver"):SetIndex(999)
	local x,y = this:GetRelPos()
	handle:Lookup("Image_COver"):SetRelPos(x-3,y-3)
	handle:Lookup("Shadow_CCOver"):Show()
	handle:Lookup("Shadow_CCOver"):SetColorRGB(this:GetColorRGB())
	local r,g,b = this:GetColorRGB()
	handle:Lookup("Text_RGB"):SetText("R="..r..",G="..g..",B="..b)
	handle:FormatAllItemPos()
end
function Snow_OTBarColorPanel.OnItemMouseLeave()
	local handle = Station.Lookup("Topmost/Snow_OTBarColorPanel"):Lookup("","Handle_Color")
	handle:Lookup("Image_COver"):Hide()
	handle:Lookup("Shadow_CCOver"):Hide()
	handle:Lookup("Text_RGB"):SetText("Ԥ˫ȷ")
end

function Snow_OTBarColorPanel.OnFrameCreate()
-- Width=484
-- Height=480
	local fx, fy = Station.GetClientSize()
	Station.Lookup("Topmost/Snow_OTBarColorPanel"):SetAbsPos((fx-480)/2,(fy-484)/2)
	local handle = Station.Lookup("Topmost/Snow_OTBarColorPanel"):Lookup("","Handle_Color")
	local t = {
		{255,0,0},
		{255,64,0},
		{255,192,0},
		{255,255,0},
		{128,255,0},
		{64,255,0},
		{0,255,128},
		{0,255,255},
		{0,192,255},
		{0,128,255},
		{0,64,255},
		{0,0,255},
		{128,0,255},
		{255,0,255},
		{255,0,128},
		{255,0,64},
	}
	for y = 1 , 16 do
		for x = 1 , 18 do
			local item = handle:AppendItemFromIni("Interface\\Snow_OTBar\\Snow_OTBarColorPanel.ini","Shadow_Color","Shadow_Color_"..x..y)
			item:SetRelPos((x-1) * 26 + 10, (y-1) * 25 + 10)
			local r,g,b = unpack(t[y])

			if x <= 9 then -- 255
				local x1 = 10 - x
				r = math.ceil(r + x1 * ((255 - r) / 11))
				g = math.ceil(g + x1 * ((255 - g) / 11))
				b = math.ceil(b + x1 * ((255 - b) / 11))
			else
				local x1 = 10 - (18 - x)
				r = math.ceil(r - x1 * (r / 13))
				g = math.ceil(g - x1 * (g / 13))
				b = math.ceil(b - x1 * (b / 13))

			end

			if r > 255 then r = 255 end
			if g > 255 then g = 255 end
			if b > 255 then b = 255 end
			if r < 0 then r = 0 end
			if g < 0 then g = 0 end
			if b < 0 then b = 0 end

			item:SetColorRGB(r,g,b)
		end
	end
	for i = 1 , 16 do
		local item = handle:AppendItemFromIni("Interface\\Snow_OTBar\\Snow_OTBarColorPanel.ini","Shadow_Color","Shadow_Color_X"..i)
		item:SetRelPos(i * 26 + 10, 16 * 25 + 10)
		local r,g,b = unpack(t[i])
		item:SetColorRGB(r,g,b)
	end
	for i = 0 , 5 do
		local item = handle:AppendItemFromIni("Interface\\Snow_OTBar\\Snow_OTBarColorPanel.ini","Shadow_Color","Shadow_Color_X"..i)
		item:SetRelPos((17-i) * 26 + 10, 17 * 25 + 10)
		local r = math.ceil(0 + i * 51)
		local g = math.ceil(0 + i * 51)
		local b = math.ceil(0 + i * 51)
		item:SetColorRGB(r,g,b)
	end
	handle:FormatAllItemPos()

end

function Snow_OTBarColorPanel.OpenColorTablePanel(fcAction)
	Station.SetActiveFrame("Topmost/Snow_OTBarColorPanel")
	Station.Lookup("Topmost/Snow_OTBarColorPanel"):Show()
	_Snow_OTBarColorPanel.f = fcAction
end

RegisterEvent("LOGIN_GAME", function()
	Station.Lookup("Topmost/Snow_OTBarColorPanel"):Hide()
end)

Wnd.OpenWindow("Interface\\Snow_OTBar\\Snow_OTBarColorPanel.ini", "Snow_OTBarColorPanel")
