Snow_OTBarFont =
{
szName = "",
nSkillr = 255,
nSkillg = 255,
nSkillb = 255,
nTimer = 255,
nTimeg = 255,
nTimeb = 255,
nSkillFont = -1,
nTimeFont = -1,
nSkillScale = -1,
nTimeScale = -1,
}

function Snow_OTBarFont.OnFrameCreate()

	this:SetPoint("CENTER",0,0,"CENTER",0,0)

	Snow_OTBarFont.nSkillr = Snow_OTBarSetting.CurrentSetting.TextName.nR
	Snow_OTBarFont.nSkillg = Snow_OTBarSetting.CurrentSetting.TextName.nG
	Snow_OTBarFont.nSkillb = Snow_OTBarSetting.CurrentSetting.TextName.nB
	Snow_OTBarFont.nSkillFont = Snow_OTBarSetting.CurrentSetting.TextName.nFont
	Snow_OTBarFont.nSkillScale = Snow_OTBarSetting.CurrentSetting.TextName.nScale
	Snow_OTBarFont.nTimer = Snow_OTBarSetting.CurrentSetting.TextTime.nR
	Snow_OTBarFont.nTimeg = Snow_OTBarSetting.CurrentSetting.TextTime.nG
	Snow_OTBarFont.nTimeb = Snow_OTBarSetting.CurrentSetting.TextTime.nB
	Snow_OTBarFont.nTimeFont = Snow_OTBarSetting.CurrentSetting.TextTime.nFont
	Snow_OTBarFont.nTimeScale = Snow_OTBarSetting.CurrentSetting.TextTime.nScale

	Snow_OTBarFont.UpdateFont()
	Snow_OTBarFont.UpdateTitle()
	Snow_OTBarFont.UpdateColor()
	Snow_OTBarFont.UpdateScale()

	this:Lookup("Btn_Apply"):Enable(false)

end

function Snow_OTBarFont.UpdateFont()

	local frame = Station.Lookup("Normal1/Snow_OTBarFont")
	local handle = frame:Lookup("",""):Lookup("Handle_List")

	handle:Clear()

	local nNum = - 1
	for i = 1,44 do
		for j = 1,5 do --5
			nNum = nNum + 1
			local hI = handle:AppendItemFromIni("interface\\Snow_OTBar\\Snow_OTBarFont.ini","Handle_Item","Font_"..tostring(nNum))
			hI:SetRelPos((j - 1) * 84,(i - 1) *84)
			hI:Lookup("Image_CoverBg"):Hide()
			hI:Lookup("Text_Font"):SetText(""..tostring(nNum))
			hI:Lookup("Text_Font"):SetFontScheme(nNum)
		end
	end

	Snow_OTBarFont.UpdateScrollInfo(handle)

end

function Snow_OTBarFont.UpdateScale()

	local frame = Station.Lookup("Normal1/Snow_OTBarFont")
	local handle = frame:Lookup("Scroll_List_Scale")
	handle:SetStepCount(50)

	if Snow_OTBarFont.szName == "" then
		frame:Lookup("",""):Lookup("Text_Scale"):SetText(Snow_OTBarSetting.CurrentSetting.TextName.nScale)
		handle:SetScrollPos(50 - Snow_OTBarSetting.CurrentSetting.TextName.nScale * 10)
	elseif Snow_OTBarFont.szName == "ʱ" then
		frame:Lookup("",""):Lookup("Text_Scale"):SetText(Snow_OTBarSetting.CurrentSetting.TextTime.nScale)
		handle:SetScrollPos(50 - Snow_OTBarSetting.CurrentSetting.TextTime.nScale * 10)
	end

end

function Snow_OTBarFont.UpdateTitle()

	local frame = Station.Lookup("Normal1/Snow_OTBarFont")
	frame:Lookup("",""):Lookup("Text_Title"):SetText("ѡ<<"..Snow_OTBarFont.szName..">>")

end

function Snow_OTBarFont.UpdateColor()

	local frame = Station.Lookup("Normal1/Snow_OTBarFont")
	local shadow = frame:Lookup("",""):Lookup("Shadow_Color")
	if Snow_OTBarFont.szName == "" then
		shadow:SetColorRGB(Snow_OTBarSetting.CurrentSetting.TextName.nR,Snow_OTBarSetting.CurrentSetting.TextName.nG,Snow_OTBarSetting.CurrentSetting.TextName.nB)
	elseif Snow_OTBarFont.szName == "ʱ" then
		shadow:SetColorRGB(Snow_OTBarSetting.CurrentSetting.TextTime.nR,Snow_OTBarSetting.CurrentSetting.TextTime.nG,Snow_OTBarSetting.CurrentSetting.TextTime.nB)
	end

end

--======================================--
function Snow_OTBarFont.UpdateScrollInfo(handle)

	local szName = handle:GetName()
	handle:FormatAllItemPos()
	local frame = handle:GetRoot()
	local wA, hA = handle:GetAllItemSize()
	local w, h = handle:GetSize()
	local nStep = (hA - h) / 10
	if nStep > 0 then
		frame:Lookup("Scroll_List"):Show()
		frame:Lookup("Btn_Up"):Show()
		frame:Lookup("Btn_Down"):Show()
	else
		frame:Lookup("Scroll_List"):Hide()
		frame:Lookup("Btn_Up"):Hide()
		frame:Lookup("Btn_Down"):Hide()
	end
	frame:Lookup("Scroll_List"):Lookup("Btn_Scroll"):SetSize(15,180 - nStep)
	frame:Lookup("Scroll_List"):SetStepCount(nStep)

end

function Snow_OTBarFont.OnScrollBarPosChanged()

	local szName = this:GetName()

	if szName == "Scroll_List" then
		local nCurrentValue = this:GetScrollPos()
		local frame = this:GetParent()
		if nCurrentValue == 0 then
			frame:Lookup("Btn_Up"):Enable(false)
		else
			frame:Lookup("Btn_Up"):Enable(true)
		end
		if nCurrentValue == this:GetStepCount() then
			frame:Lookup("Btn_Down"):Enable(false)
		else
			frame:Lookup("Btn_Down"):Enable(true)
		end

		local handle = frame:Lookup("", "Handle_List")
		handle:SetItemStartRelPos(0, - nCurrentValue * 10)
	elseif szName == "Scroll_List_Scale" then
		local nPos = this:GetScrollPos()
		local nTotal = this:GetStepCount()
		local frame = this:GetParent()
		local nScale = tonumber(("%.1f"):format((nTotal - nPos) / 10))
		local framepreview = Station.Lookup("Normal/Snow_OTBarPreview")
		local text

		if Snow_OTBarFont.szName == "" then
			text = framepreview:Lookup("",""):Lookup("Handle_Preview"):Lookup("Text_Preview_TextName")
			Snow_OTBarFont.nSkillScale = nScale
		elseif Snow_OTBarFont.szName == "ʱ" then
			text = framepreview:Lookup("",""):Lookup("Handle_Preview"):Lookup("Text_Preview_TextTime")
			Snow_OTBarFont.nTimeScale = nScale
		end

		text:SetFontScale(nScale)
		frame:Lookup("",""):Lookup("Text_Scale"):SetText(nScale)
		frame:Lookup("Btn_Apply"):Enable(true)
	end

end

function Snow_OTBarFont.OnLButtonDown()
	Snow_OTBarFont.OnLButtonHold()
end

function Snow_OTBarFont.OnLButtonHold()

	local szName = this:GetName()
	if szName == "Btn_Up" then
		this:GetParent():Lookup("Scroll_List"):ScrollPrev(1)
	elseif szName == "Btn_Down" then
		this:GetParent():Lookup("Scroll_List"):ScrollNext(1)
    end

end

function Snow_OTBarFont.OnItemMouseWheel()

	local szName = this:GetParent():GetName()
	local nDistance = Station.GetMessageWheelDelta()
	this:ScrollNext(nDistance)
	return 1

end
--========================================--

function Snow_OTBarFont.OnItemMouseEnter()

	local szName = this:GetName()
	if szName:match("^Font_") then
		this:Lookup("Image_CoverBg"):Show()
	end

end

function Snow_OTBarFont.OnItemMouseLeave()

	local szName = this:GetName()

	if szName:match("^Font_") then
		this:Lookup("Image_CoverBg"):Hide()
	end

end

function Snow_OTBarFont.OnLButtonClick()

	if this:GetName() == "Btn_Close" then
		if this:GetRoot():Lookup("Btn_Apply"):IsEnabled() then
			local msg =
			{
				szName = "Snow_OTBarFont.NotYetApplySetting",
				szMessage = "δӦõǰ趨ȷӦ",
				{szOption = g_tStrings.STR_HOTKEY_SURE, fnAction =
				function()
					Snow_OTBarSetting.CurrentSetting.TextName.nR = Snow_OTBarFont.nSkillr
					Snow_OTBarSetting.CurrentSetting.TextName.nG = Snow_OTBarFont.nSkillg
					Snow_OTBarSetting.CurrentSetting.TextName.nB = Snow_OTBarFont.nSkillb
					Snow_OTBarSetting.CurrentSetting.TextName.nFont = Snow_OTBarFont.nSkillFont
					Snow_OTBarSetting.CurrentSetting.TextName.nScale = Snow_OTBarFont.nSkillScale
					Snow_OTBarSetting.CurrentSetting.TextTime.nR = Snow_OTBarFont.nTimer
					Snow_OTBarSetting.CurrentSetting.TextTime.nG = Snow_OTBarFont.nTimeg
					Snow_OTBarSetting.CurrentSetting.TextTime.nB = Snow_OTBarFont.nTimeb
					Snow_OTBarSetting.CurrentSetting.TextTime.nFont = Snow_OTBarFont.nTimeFont
					Snow_OTBarSetting.CurrentSetting.TextTime.nScale = Snow_OTBarFont.nTimeScale
					Output(Snow_OTBarSetting.CurrentSetting.TextTime.nScale)
					Snow_OTBarSetting.UpdatePreview()
					Snow_OTBarFont.PanelSwitch()
					Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin] = Snow_OTBarSetting.CurrentSetting
					Snow_OTBar.ChangeSkin()
					Snow_OTBarSetting.OutputSetting(true,false)
				end},

				{szOption = g_tStrings.STR_HOTKEY_CANCEL,fnAction =
				function()
					Snow_OTBarSetting.UpdatePreview()
					Snow_OTBarFont.PanelSwitch()
				end}
			}
			MessageBox(msg)
		else
			Snow_OTBarSetting.UpdatePreview()
			Snow_OTBarFont.PanelSwitch()
		end
	elseif this:GetName() == "Btn_Apply" then
		Snow_OTBarSetting.CurrentSetting.TextName.nR = Snow_OTBarFont.nSkillr
		Snow_OTBarSetting.CurrentSetting.TextName.nG = Snow_OTBarFont.nSkillg
		Snow_OTBarSetting.CurrentSetting.TextName.nB = Snow_OTBarFont.nSkillb
		Snow_OTBarSetting.CurrentSetting.TextName.nFont = Snow_OTBarFont.nSkillFont
		Snow_OTBarSetting.CurrentSetting.TextName.nScale = Snow_OTBarFont.nSkillScale
		Snow_OTBarSetting.CurrentSetting.TextTime.nR = Snow_OTBarFont.nTimer
		Snow_OTBarSetting.CurrentSetting.TextTime.nG = Snow_OTBarFont.nTimeg
		Snow_OTBarSetting.CurrentSetting.TextTime.nB = Snow_OTBarFont.nTimeb
		Snow_OTBarSetting.CurrentSetting.TextTime.nFont = Snow_OTBarFont.nTimeFont
		Snow_OTBarSetting.CurrentSetting.TextTime.nScale = Snow_OTBarFont.nTimeScale
		Snow_OTBarSetting.UpdatePreview()
		Snow_OTBarFont.PanelSwitch()
		Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin] = Snow_OTBarSetting.CurrentSetting
		Snow_OTBar.ChangeSkin()
		Snow_OTBarSetting.OutputSetting(true,false)
		this:Enable(false)
	end

end

function Snow_OTBarFont.OnFrameKeyDown()

	local szKey = GetKeyName(Station.GetMessageKey())
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if szKey == "Esc" then
		Snow_OTBarFont.PanelSwitch()
		return 1
	end

end

function Snow_OTBarFont.OnItemLButtonClick()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal1/Snow_OTBarFont")
	local framepreview = Station.Lookup("Normal/Snow_OTBarPreview")

	if szName:match("^Font_") then
		local font = szName:match("Font_(%d+)")
		if Snow_OTBarFont.szName == "" then
			local text = framepreview:Lookup("",""):Lookup("Handle_Preview"):Lookup("Text_Preview_TextName")
			Snow_OTBarFont.nSkillFont = tonumber(font)
			text:SetFontScheme(tonumber(font))
			text:SetFontScale(Snow_OTBarFont.nSkillScale)
			text:SetFontColor(Snow_OTBarSetting.CurrentSetting.TextName.nR,Snow_OTBarSetting.CurrentSetting.TextName.nG,Snow_OTBarSetting.CurrentSetting.TextName.nB)
			frameself:Lookup("Btn_Apply"):Enable(true)
		elseif Snow_OTBarFont.szName == "ʱ" then
			local text = framepreview:Lookup("",""):Lookup("Handle_Preview"):Lookup("Text_Preview_TextTime")
			Snow_OTBarFont.nTimeFont = tonumber(font)
			text:SetFontScheme(tonumber(font))
			text:SetFontScale(Snow_OTBarFont.nTimeScale)
			text:SetFontColor(Snow_OTBarSetting.CurrentSetting.TextTime.nR,Snow_OTBarSetting.CurrentSetting.TextTime.nG,Snow_OTBarSetting.CurrentSetting.TextTime.nB)
			frameself:Lookup("Btn_Apply"):Enable(true)
		end
	elseif szName == "Shadow_Color" then
		local shadow = this
		Snow_OTBarColorPanel.OpenColorTablePanel(
		function(r,g,b)
			if Snow_OTBarFont.szName == "" then
				Snow_OTBarFont.nSkillr = r
				Snow_OTBarFont.nSkillg = g
				Snow_OTBarFont.nSkillb = b
			elseif Snow_OTBarFont.szName == "ʱ" then
				Snow_OTBarFont.nTimer = r
				Snow_OTBarFont.nTimeg = g
				Snow_OTBarFont.nTimeb = b
			end
			shadow:SetColorRGB(r,g,b)
			frameself:Lookup("Btn_Apply"):Enable(true)
		end)
	end

end

--[[function Snow_OTBarFont.OnItemLButtonDBClick()

	local szName = this:GetName()
	local frameself = Station.Lookup("Normal/Snow_OTBarSetting")

	if szName:match("^Font_") then
		local font = szName:match("Font_(%d+)")
		if Snow_OTBarFont.szName == "" then
			Snow_OTBarSetting.CurrentSetting.TextName.nFont = tonumber(font)
		elseif Snow_OTBarFont.szName == "ʱ" then
			Snow_OTBarSetting.CurrentSetting.TextTime.nFont = tonumber(font)
		end
		Snow_OTBarSetting.UpdatePreview()
		frameself:Lookup("Btn_ApplySetting"):Enable(true)
		Snow_OTBarFont.PanelSwitch()
	end
end]]

function Snow_OTBarFont.PanelSwitch()

	local frame = Station.Lookup("Normal1/Snow_OTBarFont")

	if not frame then
		Wnd.OpenWindow("interface\\Snow_OTBar\\Snow_OTBarFont.ini","Snow_OTBarFont")
	else
		Wnd.CloseWindow("Snow_OTBarFont")
	end

end
