Snow_OTBarGCD =
{
bAdjustUIPos = false,
bFade = false,
bCasting = false,
nFadeAlpha = 255,
nStartTickCount = 0,
nEndTickCount = 0,
}

Snow_OTBarGCD.UserData =
{
Anchor = {s = "BOTTOMCENTER", r = "BOTTOMCENTER",  x = 0, y = -300},
bShow = true,
}

RegisterCustomData("Snow_OTBarGCD.UserData")

function Snow_OTBarGCD.OnFrameCreate()

	this:RegisterEvent("DO_SKILL_CAST")
	this:RegisterEvent("DO_SKILL_PREPARE_PROGRESS")
	this:RegisterEvent("DO_SKILL_CHANNEL_PROGRESS")
	this:RegisterEvent("DO_SKILL_HOARD_PROGRESS")

	this:RegisterEvent("UI_SCALED")
	this:RegisterEvent("ON_ENTER_CUSTOM_UI_MODE")
	this:RegisterEvent("ON_LEAVE_CUSTOM_UI_MODE")
	this:RegisterEvent("CUSTOM_DATA_LOADED")

	Snow_OTBarGCD.UpdateAnchor(this)

end

function Snow_OTBarGCD.OnEvent(szEvent)

	if szEvent == "DO_SKILL_PREPARE_PROGRESS" or szEvent == "DO_SKILL_CHANNEL_PROGRESS" or szEvent == "DO_SKILL_HOARD_PROGRESS" then
		Snow_OTBarGCD.PrepareBar()
	elseif szEvent == "DO_SKILL_CAST" then
		if arg0 == GetClientPlayer().dwID then
			Snow_OTBarGCD.PrepareBar()
		end
	elseif szEvent == "UI_SCALED" then
		Snow_OTBarGCD.UpdateAnchor(this)
	elseif szEvent == "ON_ENTER_CUSTOM_UI_MODE" or szEvent == "ON_LEAVE_CUSTOM_UI_MODE" then
		Snow_OTBarGCD.UpdatePos(this)
	elseif szEvent == "CUSTOM_DATA_LOADED" then
		if arg0 == "Role" then
			if Snow_OTBarGCD.UserData.bShow then
				local frame = Wnd.OpenWindow("Interface\\Snow_OTBar\\Snow_OTBarGCD.ini","Snow_OTBarGCD")
				frame:Hide()
			else
				Wnd.CloseWindow("Snow_OTBarGCD")
			end
		end
	end

end

function Snow_OTBarGCD.OnFrameRender()

	if Snow_OTBarGCD.bAdjustUIPos then
		return
	end

	if GetTickCount() > Snow_OTBarGCD.nEndTickCount and Snow_OTBarGCD.nFadeAlpha > 0 then
		Snow_OTBarGCD.bFade = true
	end

	----------
	if Snow_OTBarGCD.bFade then

		if Snow_OTBarGCD.bCasting then
			Snow_OTBarGCD.bCasting = false
		end

		local frame = Station.Lookup("Topmost2/Snow_OTBarGCD")
		frame:SetAlpha(Snow_OTBarGCD.nFadeAlpha)
		Snow_OTBarGCD.nFadeAlpha = Snow_OTBarGCD.nFadeAlpha - 30
		if Snow_OTBarGCD.nFadeAlpha <= 0 then
			frame:Hide()
			Snow_OTBarGCD.nFadeAlpha = 0
			Snow_OTBarGCD.bFade = false
		end
	end

	Snow_OTBarGCD.UpdateBar()

end

function Snow_OTBarGCD.UpdateAnchor(frame)
	frame:SetPoint(Snow_OTBarGCD.UserData.Anchor.s, 0, 0, Snow_OTBarGCD.UserData.Anchor.r, Snow_OTBarGCD.UserData.Anchor.x, Snow_OTBarGCD.UserData.Anchor.y)
	frame:CorrectPos()
end

function Snow_OTBarGCD.OnFrameDragEnd()
	this:CorrectPos()
	Snow_OTBarGCD.UserData.Anchor = GetFrameAnchor(this)
end

function Snow_OTBarGCD.UpdatePos(frame)

	local handle = frame:Lookup("","")
	local page = frame:Lookup("Wnd_CustomMode")
	local bIn = UpdateCustomModeWindow(frame,"Сѩ--GCD",true)

	if bIn then
		Snow_OTBarGCD.bAdjustUIPos = true
		frame:Show()
		frame:EnableDrag(true)
		frame:SetMousePenetrable(false)
		frame:SetAlpha(255)
	else
		if not frame.bShow then
			Snow_OTBarGCD.bAdjustUIPos = false
			frame:EnableDrag(false)
			frame:SetMousePenetrable(true)
			page:Hide()
			frame:Hide()
		end
	end

end


function Snow_OTBarGCD.PrepareBar()

	local player = GetClientPlayer()

	local gcd = 605

	if player.dwForceID == 10 then
		gcd = 3967
	elseif player.dwForceID == 3 then
		if arg1 == 402 or --
		arg1 == 404 then --
			gcd = 404
		end
	end

	local bCool,nLeft,nTotal = player.GetSkillCDProgress(gcd,1)

	if not bCool then
		return
	end

	if nLeft == 0 then
		return
	end

	if Snow_OTBarGCD.bCasting then
		return
	end

	Snow_OTBarGCD.nStartTickCount = GetTickCount()
	Snow_OTBarGCD.nEndTickCount = GetTickCount() + nTotal * 1000 / GLOBAL.GAME_FPS

	local frame = Station.Lookup("Topmost2/Snow_OTBarGCD")

	frame:Show()
	Snow_OTBarGCD.nFadeAlpha =  255
	Snow_OTBarGCD.bCasting = true

end

function Snow_OTBarGCD.UpdateBar()

	local frame = Station.Lookup("Topmost2/Snow_OTBarGCD")
	local handle = frame:Lookup("","")

	if GetTickCount() > Snow_OTBarGCD.nEndTickCount then
		return
	end

	frame:SetAlpha(255)

	local currenttime = tonumber(("%.2f"):format((GetTickCount() - Snow_OTBarGCD.nStartTickCount)/1000))
	local totaltime = tonumber(("%.2f"):format((Snow_OTBarGCD.nEndTickCount - Snow_OTBarGCD.nStartTickCount)/1000))
	local nPercentage = currenttime / totaltime

	if nPercentage > 1 then
		nPercentage = 1
	end

	handle:Lookup("Image_Progress"):SetPercentage(nPercentage)
	handle:Lookup("Text_Time"):SetText(tostring(("%.2f"):format(currenttime)).."/"..tostring(("%.2f"):format(totaltime)))
	handle:Lookup("Image_Background"):SetAlpha(50)
	handle:Lookup("Image_Progress"):SetAlpha(200)

end

Wnd.OpenWindow("Interface\\Snow_OTBar\\Snow_OTBarGCD.ini","Snow_OTBarGCD")
