Snow_OTBarOption =
{
nStepper = 0,
bShowLink = false,
bShowOrHide = true,
bInProgress = false,
}

Snow_OTBarOption.UserData =
{
Anchor = {s = "CENTER", r = "CENTER",  x = 0, y = 0},
bShow = true,
}

RegisterCustomData("Snow_OTBarOption.UserData")

function Snow_OTBarOption.OnFrameCreate()

	local cat = this:Lookup("",""):Lookup("Animate_Cat")
	local skin = Station.Lookup("Normal/Snow_OTBarOption"):Lookup("",""):Lookup("Image_Skin")
	skin:Hide()

	cat:SetAnimate("interface\\Snow_OTBar\\Misc\\OptionPanel.UITex",0)
	cat:SetAlpha(200)

	this:RegisterEvent("UI_SCALED")
	this:RegisterEvent("CUSTOM_DATA_LOADED")
	this:RegisterEvent("LOADING_END")

	Snow_OTBarOption.UpdateAnchor(this)

end

function Snow_OTBarOption.OnFrameRender()

	local skin = Station.Lookup("Normal/Snow_OTBarOption"):Lookup("",""):Lookup("Image_Skin")

	if not Snow_OTBar.bShowLink then
		return
	end

	Snow_OTBarOption.bInProgress = true
	skin:Show()

	Snow_OTBarOption.nStepper = Snow_OTBarOption.nStepper + 1
	if Snow_OTBarOption.nStepper > 30 then
		Snow_OTBarOption.nStepper = 30
	end

	local value = -1
	if Snow_OTBar.bShowOrHide then
		value = Snow_OTBarOption.nStepper/30
	else
		value = 1 - (Snow_OTBarOption.nStepper/30)
	end

	skin:SetPercentage(value)

	if Snow_OTBarOption.nStepper == 30 then
		Snow_OTBar.bShowLink = false
		Snow_OTBarOption.bInProgress = false
		if Snow_OTBar.bShowOrHide then
			skin:Show()
		else
			skin:Hide()
		end
	end

end

function Snow_OTBarOption.OnEvent(szEvent)

	if szEvent == "CUSTOM_DATA_LOADED" then
		if arg0 == "Role" then
			Snow_OTBarOption.UpdateAnchor(this)
		end
	elseif szEvent == "UI_SCALED" then
		Snow_OTBarOption.UpdateAnchor(this)
	elseif szEvent == "LOADING_END" then
		Snow_OTBarSetting.InputSetting(true,false)
		Snow_OTBar.ChangeSkin()
		if not Snow_OTBarOption.UserData.bShow then
			Wnd.CloseWindow("Snow_OTBarOption")
		end
	end

end

function Snow_OTBarOption.OnFrameDragEnd()
	this:CorrectPos()
	Snow_OTBarOption.UserData.Anchor = GetFrameAnchor(this)
end

function Snow_OTBarOption.UpdateAnchor(frame)
	frame:SetPoint(Snow_OTBarOption.UserData.Anchor.s, 0, 0, Snow_OTBarOption.UserData.Anchor.r, Snow_OTBarOption.UserData.Anchor.x, Snow_OTBarOption.UserData.Anchor.y)
	frame:CorrectPos()
end

function Snow_OTBarOption.OnItemMouseEnter()

	local szName = this:GetName()

	if szName == "Animate_Cat" then
		local szTip = ""

		if Snow_OTBar.bShowOrHide then
			szTip = "<Text>text="..EncodeComponentsString("˫Ҽ\n").." font=5 r=255 g=255 b=0</text>"
		else
			szTip = "<Text>text="..EncodeComponentsString("˫չҼ\n").." font=5 r=255 g=255 b=0</text>"
		end

		local nX, nY = this:GetAbsPos()
		OutputTip(szTip, 345, {nX, nY, 0, 0})
		this:SetAlpha(255)
		this:SetRelPos(-1.5,-1.5)
		this:SetSize(48,48)
		this:GetParent():FormatAllItemPos()
	elseif szName == "Image_Skin" then
		this:SetFrame(12)
		local szTip = "<Text>text="..EncodeComponentsString("ҳ").." font=5 r=255 g=255 b=0</text>"
		local nX, nY = this:GetAbsPos()
		OutputTip(szTip, 345, {nX, nY, 0, 0})
	end

end

function Snow_OTBarOption.OnItemMouseLeave()

	local szName = this:GetName()

	if szName == "Animate_Cat" then
		HideTip()
		this:SetAlpha(200)
		this:SetRelPos(0,0)
		this:SetSize(45,45)
		this:GetParent():FormatAllItemPos()
	elseif szName == "Image_Skin" then
		this:SetFrame(13)
		HideTip()
	end

end

function Snow_OTBarOption.OnItemLButtonClick()

	local szName = this:GetName()
	if szName == "Image_Skin" then
		OpenInternetExplorer("http://www.jx3pve.com/snow")
	end

end

function Snow_OTBarOption.OnItemLButtonDBClick()
	local szName = this:GetName()

	if szName == "Animate_Cat" then
		HideTip()
		if Snow_OTBarOption.bInProgress then
			Snow_OTBarOption.nStepper = 0
		else
			Snow_OTBar.bShowLink =  not Snow_OTBar.bShowLink
			Snow_OTBar.bShowOrHide = not Snow_OTBar.bShowOrHide
			Snow_OTBarOption.nStepper = 0
		end
	end
end

function Snow_OTBarOption.OnItemRButtonClick()

	local szName = this:GetName()

	if szName == "Animate_Cat" then
		HideTip()
		PopupMenu(Snow_OTBarOption.GetMenu())
	end

end

function Snow_OTBarOption.GetMenu()

	local showtext = ""
	local errortext = ""
	local showcattext = ""
	local showgcdtext = ""

	if Snow_OTBar.UserData.bCloseSystemBar then
		showtext = "ϵͳ"
	else
		showtext = "رϵͳ"
	end

	if Snow_OTBar.UserData.bShowError then
		errortext = "رձ"
	else
		errortext = ""
	end

	if Snow_OTBarOption.UserData.bShow then
		showcattext = "Ĭèè"
	else
		showcattext = "ĬϿèè"
	end

	if Snow_OTBarGCD.UserData.bShow then
		showgcdtext = "رGCD"
	else
		showgcdtext = "GCD"
	end

	local menu =
	{
		{
			szOption = "߼",fnAction = function() Snow_OTBarSetting.PanelSwitch() end
		},
		{bDevide = true},
		{
			szOption = showtext,fnAction =
			function()
				Snow_OTBar.UserData.bCloseSystemBar = not Snow_OTBar.UserData.bCloseSystemBar
				if Snow_OTBar.UserData.bCloseSystemBar then
					Wnd.CloseWindow("OTActionBar")
				else
					local msg =
					{
						szName = "Snow_OTBarOption.OpenSystemBar",
						szMessage = "С˺Ч",
						{szOption = g_tStrings.STR_HOTKEY_SURE}
					}
					MessageBox(msg)
				end
			end
		}
	}
	local submenu =
	{
		szOption = "Ƥ",
	}

	for i = 1, #Snow_OTBarSkinList do
		table.insert(submenu,
		{
			szOption = Snow_OTBarSkinList[i],fnAction =
			function()
				local frame = Station.Lookup("Normal/Snow_OTBarSetting")
				if frame then
					frame:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):SetFrame(0)
					frame:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):Hide()
					Snow_OTBarSetting.UserData.szCurrentSkin = Snow_OTBarSkinList[i]
					Snow_OTBarSetting.CurrentSetting = Snow_OTBarSetting.SkinScheme[Snow_OTBarSetting.UserData.szCurrentSkin]
					Snow_OTBarSetting.UpdateSetting(Snow_OTBarSetting.CurrentSetting)
					frame:Lookup("Btn_ApplySetting"):Enable(false)
					frame:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):SetFrame(1)
					frame:Lookup("",""):Lookup("Handle_List"):Lookup("Handle_Item_"..Snow_OTBarSetting.UserData.szCurrentSkin):Lookup("Image_ItemBg"):Show()
				else
					Snow_OTBarSetting.UserData.szCurrentSkin = Snow_OTBarSkinList[i]
				end
				Snow_OTBar.ChangeSkin()
			end,
			bMCheck = true,
			bChecked = Snow_OTBarSetting.UserData.szCurrentSkin == Snow_OTBarSkinList[i],
			fnAutoClose = function() return true end
		}
		)
	end

	table.insert(menu,submenu)
	table.insert(menu,{bDevide = true})

	local misc = {szOption = ""}

	table.insert(misc,
	{
		szOption = showcattext,fnAction =
		function()
			Snow_OTBarOption.UserData.bShow = not Snow_OTBarOption.UserData.bShow
			if Snow_OTBarOption.UserData.bShow then
				OutputMessage("MSG_SYS","ĬϿèè\n")
			else
				OutputMessage("MSG_SYS","Ĭèè\n")
				Snow_OTBarOption.PanelSwitch()
			end
		end
	})
	table.insert(misc,
	{
		szOption = "ò",fnAction =
		function()
			local msg =
			{
				szName = "Snow_OTBarOption.RestoreDefault",
				szMessage = "Ƿò  ע滵ʹ",
				{szOption = g_tStrings.STR_HOTKEY_SURE,fnAction =
				function()
					Snow_OTBar = {}
					Snow_OTBarSetting = {}
					Snow_OTBarOption = {}
					ReInitUI(LOAD_LOGIN_REASON.RETURN_ROLE_LIST)
				end
				},
				{szOption = g_tStrings.STR_HOTKEY_CANCEL}
			}
			MessageBox(msg)
		end
	})

	table.insert(misc,
	{
		szOption = errortext,fnAction =
		function()
			Snow_OTBar.UserData.bShowError = not Snow_OTBar.UserData.bShowError
			if Snow_OTBar.UserData.bShowError then
				OutputMessage("MSG_SYS","ѿ\n")
			else
				OutputMessage("MSG_SYS","ѹر\n")
			end
		end
	})

	table.insert(misc,
	{
		szOption = showgcdtext,fnAction =
		function()
			Snow_OTBarGCD.UserData.bShow = not Snow_OTBarGCD.UserData.bShow
			if Snow_OTBarGCD.UserData.bShow then
				local frame = Wnd.OpenWindow("Interface\\Snow_OTBar\\Snow_OTBarGCD.ini","Snow_OTBarGCD")
				frame:Hide()
				OutputMessage("MSG_SYS","CDѿ\n")
			else
				Wnd.CloseWindow("Snow_OTBarGCD")
				OutputMessage("MSG_SYS","CDѹر\n")
			end
		end
	})

	table.insert(menu,misc)

	return menu
end

function Snow_OTBarOption.PanelSwitch()

	local frame = Station.Lookup("Normal/Snow_OTBarOption")
	if not frame then
		Wnd.OpenWindow("interface\\Snow_OTBar\\Snow_OTBarOption.ini","Snow_OTBarOption")
	else
		Wnd.CloseWindow("Snow_OTBarOption")
	end

end


Hotkey.AddBinding("Snow_OTBarOpt","èèý","Сѩ",
	function()
		Snow_OTBarOption.PanelSwitch()
	end,
	nil
)

Snow_OTBarOption.PanelSwitch()

-- internet exploere
if not OpenInternetExplorer then
	function IsInternetExplorerOpened(nIndex)
		local frame = Station.Lookup("Topmost/IE"..nIndex)
		if frame and frame:IsVisible() then
			return true
		end
		return false
	end

	function IE_GetNewIEFramePos()
		local nLastTime = 0
		local nLastIndex = nil
		for i = 1, 10, 1 do
			local frame = Station.Lookup("Topmost/IE"..i)
			if frame and frame:IsVisible() then
				if frame.nOpenTime > nLastTime then
					nLastTime = frame.nOpenTime
					nLastIndex = i
				end
			end
		end
		if nLastIndex then
			local frame = Station.Lookup("Topmost/IE"..nLastIndex)
			x, y = frame:GetAbsPos()
			local wC, hC = Station.GetClientSize()
			if x + 890 <= wC and y + 630 <= hC then
				return x + 30, y + 30
			end
		end
		return 40, 40
	end

	function OpenInternetExplorer(szAddr, bDisableSound)
		local nIndex, nLast = nil, nil
		for i = 1, 10, 1 do
			if not IsInternetExplorerOpened(i) then
				nIndex = i
				break
			elseif not nLast then
				nLast = i
			end
		end
		if not nIndex then
			OutputMessage("MSG_ANNOUNCE_RED", g_tStrings.MSG_OPEN_TOO_MANY)
			return nil
		end
		local x, y = IE_GetNewIEFramePos()
		local frame = Wnd.OpenWindow("InternetExplorer", "IE"..nIndex)
		frame.bIE = true
		frame.nIndex = nIndex

		frame:BringToTop()
		if nLast then
			frame:SetAbsPos(x, y)
			frame:CorrectPos()
			frame.x = x
			frame.y = y
		else
			frame:SetPoint("CENTER", 0, 0, "CENTER", 0, 0)
			frame.x, frame.y = frame:GetAbsPos()
		end
		local webPage = frame:Lookup("WebPage_Page")
		if szAddr then
			webPage:Navigate(szAddr)
		end
		Station.SetFocusWindow(webPage)
		if not bDisableSound then
			PlaySound(SOUND.UI_SOUND,g_sound.OpenFrame)
		end
		return webPage
	end
end
